net.sf.saxon.expr.instruct

## Class CallTemplate

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.CallTemplate

- All Implemented Interfaces:
    Serializable, SourceLocator, LocationProvider, SaxonLocator, ITemplateCall, TailCallReturner, InstructionInfo, Locator

      public class CallTemplate
      extends Instruction
      implements ITemplateCall

  Instruction representing an xsl:call-template element in the stylesheet.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `CallTemplate.CallTemplatePackage` A CallTemplatePackage is an object that encapsulates the name of a template to be called, the parameters to be supplied, and the execution context.

  - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CallTemplate(Template template, boolean useTailRecursion, Expression calledTemplateExpression, NamespaceResolver nsContext)` Construct a CallTemplate instruction.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `computeCardinality()` Get the cardinality of the sequence returned by evaluating this instruction
    `Expression` | `copy()` Copy an expression.
    `boolean` | `createsNewNodes()` Determine whether this instruction creates new nodes.
    `void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
    `WithParam[]` | `getActualParams()` Get the actual parameters passed to the called template
    `Expression` | `getCalledTemplateExpression()`
    `ExpressionCompiler` | `getExpressionCompiler()` Return the compiler of the CallTemplate expression
    `int` | `getInstructionNameCode()` Return the name of this instruction.
    `int` | `getIntrinsicDependencies()` Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions.
    `ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the items returned by evaluating this instruction
    `NamespaceResolver` | `getNsContext()`
    `StructuredQName` | `getObjectName()` Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc.
    `Template` | `getTargetTemplate()` Get the target template, if known statically
    `Template` | `getTargetTemplate(XPathContext context)` Get the template, in the case where it is specified dynamically.
    `WithParam[]` | `getTunnelParams()` Get the tunnel parameters passed to the called template
    `Iterator<Expression>` | `iterateSubExpressions()` Get all the XPath expressions associated with this instruction (in XSLT terms, the expression present on attributes of the instruction, as distinct from the child instructions in a sequence construction)
    `Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
    `void` | `process(XPathContext context)` Process this instruction, without leaving any tail calls.
    `TailCall` | `processLeavingTail(XPathContext context)` Process this instruction.
    `protected void` | `promoteInst(PromotionOffer offer)` Handle promotion offers, that is, non-local tree rewrites.
    `boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
    `void` | `setActualParameters(WithParam[] actualParams, WithParam[] tunnelParams)` Set the actual parameters on the call
    `Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression.
    `Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform type checking of an expression and its subexpressions.
    `boolean` | `usesTailRecursion()` Ask whether this is a tail call

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, computeSpecialProperties, dynamicError, evaluateAsString, evaluateItem, getConstructType, getExpressionName, getImplementationMethod, getInstructionName, getIteratorFromProcessMethod, getSourceLocator, isXSLT, iterate, promote`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntegerBounds, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getStreamability, getStreamingAdjunct, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, iterateSubExpressionInfo, markTailFunctionCalls, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toPattern, toStreamingPattern, toString, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javax.xml.transform.SourceLocator

      `getColumnNumber, getLineNumber, getPublicId, getSystemId`

- - ### Constructor Detail

    - #### CallTemplate

          public CallTemplate(Template template,
                      boolean useTailRecursion,
                      Expression calledTemplateExpression,
                      NamespaceResolver nsContext)

      Construct a CallTemplate instruction.
      Parameters:
        `template` - the Template object identifying the template to be called, in the normal case where this is known statically
        `useTailRecursion` - true if the call is potentially tail recursive
        `calledTemplateExpression` - expression to calculate the name of the template to be called at run-time, this supports the saxon:allow-avt option
        `nsContext` - the static namespace context of the instruction, needed only in the case where the name of the called template is to be calculated dynamically

  - ### Method Detail

    - #### getCalledTemplateExpression

          public Expression getCalledTemplateExpression()

    - #### getNsContext

          public NamespaceResolver getNsContext()

    - #### setActualParameters

          public void setActualParameters(WithParam[] actualParams,
                                 WithParam[] tunnelParams)

      Set the actual parameters on the call
      Parameters:
        `actualParams` - the parameters that are not tunnel parameters
        `tunnelParams` - the tunnel parameters

    - #### getActualParams

          public WithParam[] getActualParams()

      Get the actual parameters passed to the called template
      Specified by:
        `getActualParams` in interface `ITemplateCall`
      Returns:
        the non-tunnel parameters

    - #### getTunnelParams

          public WithParam[] getTunnelParams()

      Get the tunnel parameters passed to the called template
      Specified by:
        `getTunnelParams` in interface `ITemplateCall`
      Returns:
        the tunnel parameters

    - #### getTargetTemplate

          public Template getTargetTemplate()

      Get the target template, if known statically
      Returns:
        the target template

    - #### usesTailRecursion

          public boolean usesTailRecursion()

      Ask whether this is a tail call
      Returns:
        true if this is a tail call

    - #### getInstructionNameCode

          public int getInstructionNameCode()

      Return the name of this instruction.
      Overrides:
        `getInstructionNameCode` in class `Instruction`
      Returns:
        a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

    - #### simplify

          public Expression simplify(ExpressionVisitor visitor)
                              throws XPathException

      Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression).
      Specified by:
        `simplify` in class `Instruction`
      Parameters:
        `visitor` - an expression visitor
      Returns:
        the simplified expression
      Throws:
        `XPathException` - if an error is discovered during expression rewriting

    - #### typeCheck

          public Expression typeCheck(ExpressionVisitor visitor,
                             ExpressionVisitor.ContextItemType contextItemType)
                               throws XPathException

      Description copied from class: `Expression`
      Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

      This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

      If the implementation returns a value other than "this", then it is required to ensure that the location information in the returned expression have been set up correctly. It should not rely on the caller to do this, although for historical reasons many callers do so.

      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### optimize

          public Expression optimize(ExpressionVisitor visitor,
                            ExpressionVisitor.ContextItemType contextItemType)
                              throws XPathException

      Description copied from class: `Expression`
      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### computeCardinality

          public int computeCardinality()

      Get the cardinality of the sequence returned by evaluating this instruction
      Overrides:
        `computeCardinality` in class `Instruction`
      Returns:
        the static cardinality

    - #### getItemType

          public ItemType getItemType(TypeHierarchy th)

      Get the item type of the items returned by evaluating this instruction
      Overrides:
        `getItemType` in class `Instruction`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        the static item type of the instruction

    - #### copy

          public Expression copy()

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Returns:
        the copy of the original expression

    - #### getIntrinsicDependencies

          public int getIntrinsicDependencies()

      Description copied from class: `Expression`
      Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions. For example, position() has an intrinsic dependency on the context position, while (position()+1) does not. The default implementation of the method returns 0, indicating "no dependencies".
      Overrides:
        `getIntrinsicDependencies` in class `Expression`
      Returns:
        a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

    - #### createsNewNodes

          public final boolean createsNewNodes()

      Determine whether this instruction creates new nodes. This implementation currently returns true unconditionally.
      Overrides:
        `createsNewNodes` in class `Instruction`
      Returns:
        true if the instruction creates new nodes (or if it can't be proved that it doesn't)

    - #### iterateSubExpressions

          public Iterator<Expression> iterateSubExpressions()

      Get all the XPath expressions associated with this instruction (in XSLT terms, the expression present on attributes of the instruction, as distinct from the child instructions in a sequence construction)
      Overrides:
        `iterateSubExpressions` in class `Expression`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### replaceSubExpression

          public boolean replaceSubExpression(Expression original,
                                     Expression replacement)

      Replace one subexpression by a replacement subexpression
      Overrides:
        `replaceSubExpression` in class `Expression`
      Parameters:
        `original` - the original subexpression
        `replacement` - the replacement subexpression
      Returns:
        true if the original subexpression is found

    - #### promoteInst

          protected void promoteInst(PromotionOffer offer)
                              throws XPathException

      Handle promotion offers, that is, non-local tree rewrites.
      Overrides:
        `promoteInst` in class `Instruction`
      Parameters:
        `offer` - The type of rewrite being offered
      Throws:
        `XPathException`

    - #### process

          public void process(XPathContext context)
                       throws XPathException

      Process this instruction, without leaving any tail calls.
      Overrides:
        `process` in class `Instruction`
      Parameters:
        `context` - the dynamic context for this transformation
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### processLeavingTail

          public TailCall processLeavingTail(XPathContext context)
                                      throws XPathException

      Process this instruction. If the called template contains a tail call (which may be an xsl:call-template of xsl:apply-templates instruction) then the tail call will not actually be evaluated, but will be returned in a TailCall object for the caller to execute.
      Specified by:
        `processLeavingTail` in interface `TailCallReturner`
      Specified by:
        `processLeavingTail` in class `Instruction`
      Parameters:
        `context` - the dynamic context for this transformation
      Returns:
        an object containing information about the tail call to be executed by the caller. Returns null if there is no tail call.
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the instruction

    - #### getTargetTemplate

          public Template getTargetTemplate(XPathContext context)
                                     throws XPathException

      Get the template, in the case where it is specified dynamically.
      Parameters:
        `context` - The dynamic context of the transformation
      Returns:
        The template to be called
      Throws:
        `XPathException` - if a dynamic error occurs: specifically, if the template name is computed at run-time (Saxon extension) and the name is invalid or does not reference a known template

    - #### getObjectName

          public StructuredQName getObjectName()

      Description copied from interface: `InstructionInfo`
      Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc. This is used only where the name is known statically.
      Specified by:
        `getObjectName` in interface `InstructionInfo`
      Overrides:
        `getObjectName` in class `Expression`
      Returns:
        the QName of the object declared or manipulated by this instruction or expression

    - #### getExpressionCompiler

          public ExpressionCompiler getExpressionCompiler()

      Return the compiler of the CallTemplate expression
      Overrides:
        `getExpressionCompiler` in class `Expression`
      Returns:
        the relevant ExpressionCompiler

    - #### explain

          public void explain(ExpressionPresenter out)

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `explain` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.